/*
** MixerKernel.c
**
** Here are all the functions for mixer updating. 
**
** Everything seems to run but is bad optimized.
**
** sam-lo_p@epita.fr
*/

#include<fcntl.h>
#include"DebugLib.h"
#include"DspDriver.h"
#include"DspLib.h"
#include"Constants.h"
#include"MixerTypes.h"
#include"DebugLib.h"
#include<stdlib.h>

// Remarque. La date s'exprime en mots stereo, i.e. deux mots de 16
// bits correspondent  une unit de temps. On a donc date+=BUFFER_SIZE div 4

// ----------- PRIVATE -----------

/* volume_enveloppe
   
   ^ 
   |                + (p2x,p2y)
   |	     + (Mx,My)
   | + (p1x,p1y)
   |--------------------------->
   
   Shitty formula for volume enveloppe:
   My = p1y+(p2y-p1y) * ( (Mx-p1x) / (p2x - p1x) )
   
*/

int find_point_pos(point, cur_pos)
     t_point* point;
     size_t   cur_pos;
{

  if (point != NULL)
    {
      // Looking for the first point before the zone to examine.
      while ((point->next_point != NULL) && (point->next_point->x <= cur_pos))
	{
	  point = point->next_point;
	} // while
    }
  return(0);
}

float coef_calculate(point, cur_pos)
     t_point* point;
     int      cur_pos;
{
  float result;

  result = 0;
  
  while ((point->next_point != NULL) && (point->next_point->x <= cur_pos))
    {
      point = point->next_point;
    }	
  
  if (point->next_point != NULL)
    {
      result = ( point->y+ ( point->next_point->y - point->y )*
		 ( (float) (cur_pos - point->x) / 
		   ( point->next_point->x - point->x) )) / DIV_POINT;
    }  
  else
    {
      /* No more point */
      result = (float)point->y / 256;
    }

  return(result);
}

int find_point_area(first_point, main_mixer)
     t_point*      first_point;
     t_main_mixer* main_mixer;

{

  if (first_point != NULL)
    {
      // Looking for the first point before the zone to examine.
      while ((first_point->next_point != NULL) && (first_point->next_point->x <= main_mixer->played_samples))
	{
	  first_point = first_point->next_point;
	} // while
      
      // if we are on a precise point it is now first_vol_point
      if ((first_point->next_point != NULL) && (first_point->next_point->x == main_mixer->played_samples))
	{
	  first_point = first_point->next_point;
	} // if
    }

  return(0);

} /* find_point_area */

int apply_enveloppes(main_mixer, mixer_elt)
     t_main_mixer* main_mixer;
     t_mixer_elt*  mixer_elt;

{
  t_point*     first_vol_point;
  t_point*     first_pan_point;
  t_point*     first_frq_point;
  int          i;
  int          ii;
  int          iii;
  int          inter_left;
  int          inter_right;
  float        frq_index;
  int          frq_iter;
  float        vol_pos;
  float        pan_pos, pan_left, pan_right;
  float        frq_pos;
  short int*   buf;

  // Looking for a point just before where we are
  first_vol_point = mixer_elt->mixer_info->vol_curve;
  first_pan_point = mixer_elt->mixer_info->pan_curve;

  find_point_area(first_vol_point,main_mixer);
  find_point_area(first_pan_point,main_mixer);

  if (mixer_elt->mixer_info->do_freq == TRUE_)
    {
      first_frq_point = mixer_elt->mixer_info->frq_curve;
      find_point_area(first_frq_point,main_mixer);  
    }

  frq_index = frq_iter = 0;

  if (mixer_elt->mixer_info->do_freq == TRUE_)
    {
      buf = (short int*) malloc (BUFFER_SIZE*2);
      memcpy(buf, mixer_elt->buffer, BUFFER_SIZE*2);
    } // fi

  // processing
  for(i = 0; i < (BUFFER_SIZE / 2) ; i++)
    {
      ii = i * 2; // number of words
      
      // Finding volume value
      if (first_vol_point != NULL)
	{
	  vol_pos = coef_calculate(first_vol_point, main_mixer->played_samples+i);
	}
      else
	vol_pos = 1;
      
      // Finding panning value
      if (first_pan_point != NULL)
	{
	  pan_pos = coef_calculate(first_pan_point, main_mixer->played_samples+i);
	  if (pan_pos <= 0.5)
	    {
	      pan_left  = 1;
	      pan_right = 2*pan_pos;
	    }
	  else
	    {
	      pan_right = 1;
	      pan_left = 2* (1 - pan_pos);
	    }
	}
      else
	{
	  pan_left = pan_right = 1;
	}
      
      // Finding frequency value
      if ((mixer_elt->mixer_info->do_freq == TRUE_) && (first_frq_point != NULL))
	{
	  frq_pos = coef_calculate(first_frq_point, main_mixer->played_samples+i) * 2; // 0 to 2 * frq
	}
      else
	{
	  frq_pos = 2;
	}

      // Modifying buffer values
      if (mixer_elt->mixer_info->do_freq == FALSE_)
	{
	  mixer_elt->buffer[ii]   = (int) mixer_elt->buffer[ii] * vol_pos * pan_left*mixer_elt->mixer_info->volume*mixer_elt->mixer_info->panning;   // left
	  mixer_elt->buffer[ii+1] = (int) mixer_elt->buffer[ii+1] * vol_pos*pan_right*mixer_elt->mixer_info->volume*(1-mixer_elt->mixer_info->panning); // right
	}

      else

	{
	  frq_index += frq_pos;
	  //frq_index = ((int)(frq_index - frq_iter) / 2) * 2; // nombre pair
	  if (frq_index > BUFFER_SIZE)
	    {
	      mixer_elt->read_bytes = read(mixer_elt->tempgmurf->file, 
					    buf, 
					    BUFFER_SIZE*2); /* Reading wave */
	      frq_iter += BUFFER_SIZE;
	      frq_index = 0;
	      if (mixer_elt->read_bytes == 0)
		{
		  mixer_elt->finished = TRUE_;
		}
	    } // fi
	  
	  /**/
	  
	  if (mixer_elt->read_bytes != 0)
	    {
	      iii = (int)frq_index *2 /2;

	      inter_left = (buf[iii+2] - buf[iii]) * frq_pos;
	      inter_right = (buf[iii+3] - buf[iii+1]) * frq_pos;

	      mixer_elt->buffer[ii] = (int) (buf[ iii ] + inter_left) * vol_pos * pan_left*mixer_elt->mixer_info->volume*mixer_elt->mixer_info->panning;   // left
	      mixer_elt->buffer[ii+1] = (int) (buf[ iii + 1 ] + inter_right) * vol_pos*pan_right*mixer_elt->mixer_info->volume*(1-mixer_elt->mixer_info->panning); // right
	      //DEBUG("%d %d\n",mixer_elt->buffer[ii],mixer_elt->buffer[ii+1]);
	    }
	  else
	    {
	      mixer_elt->buffer[ii] = 0;
	      mixer_elt->buffer[ii+1] = 0;
	    } // else
	} // else

    } // for

  if (mixer_elt->mixer_info->do_freq == TRUE_)
    {
      free(buf);
      lseek(mixer_elt->tempgmurf->file, - (BUFFER_SIZE - (int)frq_index) * 2, SEEK_CUR);
      //      DEBUG("(int)frq_index * 2  = %d ; BUFFER_SIZE * 2 = %d\n",(int)frq_index * 2, BUFFER_SIZE * 2);
    }


  return (0);

} /* volume_enveloppe */



/*
** ---------- reads tempgmurf files
*/

int mixer_read_files_buffers(main_mixer, result) 
     t_main_mixer* main_mixer;
     int*          result;

{
  t_mixer_elt* mixer_elt;
  int          words_to_read;

  words_to_read = 0;
  mixer_elt = main_mixer->first_mixer_elt;
  while ( mixer_elt != NULL) 
    {
      words_to_read = 0;
      mixer_elt->dsp->processed = FALSE_; /* Initializing 'processed' flag to false_ */
      mixer_elt->finished = FALSE_;       /* Initializing 'finished' flag */
      if ((mixer_elt->rec_or_play == PLAY) && (mixer_elt->finished == FALSE_))
	{
	  if (mixer_elt->mixer_info->begin_date <= main_mixer->played_samples) 
	    {
	      words_to_read = BUFFER_SIZE * 2 ; // le buffer est en words.
	    }
	  else
	    {
	      if (mixer_elt->mixer_info->begin_date <= main_mixer->played_samples+(BUFFER_SIZE / 2)) 
		// buffer_size / 4 car 2 mots  = 1 ut
		{
		  words_to_read = main_mixer->played_samples*2+(BUFFER_SIZE) - mixer_elt->mixer_info->begin_date*2;
		}
	    } /* fi */
	  mixer_elt->read_bytes = read(mixer_elt->tempgmurf->file, 
				       mixer_elt->buffer, 
				       words_to_read); /* Reading wave */
	  
	  /* Applying enveloppes here */
	  
	  apply_enveloppes(main_mixer, mixer_elt);

	  if (*result < mixer_elt->read_bytes)
	    *result = mixer_elt->read_bytes;

	  if (mixer_elt->read_bytes == 0)
	    mixer_elt->finished = TRUE_;
	  
	}
      mixer_elt = mixer_elt->next_mixer_elt;
    } /* while */
  return (0);
  
} /* mixer_read_files_buffers */


/*
** ---------- fills dsp's big_buffers 
*/

int fill_big_buffers(main_mixer) 
     t_main_mixer* main_mixer;
{
  t_mixer_elt* mixer_elt;
  int          i;

  mixer_elt = main_mixer->first_mixer_elt;

  while (mixer_elt != NULL)
    {

      if (mixer_elt->finished == FALSE_)
	{

	  if ((mixer_elt->rec_or_play == PLAY) && (mixer_elt->mute == FALSE_))
	    {
	      
	      if (mixer_elt->dsp->processed == FALSE_)
		{

		  for (i=0; i<BUFFER_SIZE; i++)
		    {
		      if (mixer_elt->mixer_info->begin_date <= main_mixer->played_samples) 
			{
			  mixer_elt->dsp->big_buf[i]  = mixer_elt->buffer[i];
			}
		      else
			{
			  if (( mixer_elt->mixer_info->begin_date <= (main_mixer->played_samples+BUFFER_SIZE*2))
			      && ((main_mixer->played_samples+i) >= mixer_elt->mixer_info->begin_date))
			    {
			      mixer_elt->dsp->big_buf[i]  = 
				mixer_elt->buffer[i-(main_mixer->played_samples*2-mixer_elt->mixer_info->begin_date*2)];
			    } /*fi*/
			  else
			    {
			      mixer_elt->dsp->big_buf[i]  = 0;
			    }
			} /*fi*/
		          
		    } /* for */
		  mixer_elt->dsp->processed = TRUE_;
		} /* fi */
	      else
		{
		  for (i=0; i<BUFFER_SIZE; i++)
		    {
		      if (i <= mixer_elt->read_bytes)
			{
			  mixer_elt->dsp->big_buf[i] += mixer_elt->buffer[i];
			} /* fi */
		    } /* for */
		} /* else */
	    } /* fi */
	} /* fi */
      mixer_elt = mixer_elt->next_mixer_elt;
    } /* while */
  return (0);
} /* fill_big_buffers */



/*
** ---------- Reinitializes "processed" flags.
*/

int init_processed_flags(main_mixer)
     t_main_mixer* main_mixer;
{
  t_mixer_elt* mixer_elt;

  mixer_elt = main_mixer->first_mixer_elt;
  while ( mixer_elt != NULL) 
    {
      mixer_elt->dsp->processed = FALSE_;/* Initializing 'processed' flag to false_ */
      mixer_elt = mixer_elt->next_mixer_elt;
    } /* while */
  return (0);
} /* init_processed_flags */



/*
** ---------- Fills dsp buffers and adjusts global volume
*/

int fill_dsp_buffer(main_mixer)
  t_main_mixer* main_mixer;
{

  t_mixer_elt* mixer_elt;
  int i;

  mixer_elt = main_mixer->first_mixer_elt;
  while (mixer_elt != NULL)
    {

      if ((mixer_elt->rec_or_play == PLAY) && (mixer_elt->finished == FALSE_) 
	  && (mixer_elt->mute == FALSE_))
	{
	  if (mixer_elt->dsp->processed == FALSE_)
	    {
	      for (i=0; i<BUFFER_SIZE; i++)
		{
		  mixer_elt->dsp->buffer[i] = mixer_elt->dsp->big_buf[i] * main_mixer->vol;
		} /* for */
	      mixer_elt->dsp->processed = TRUE_;
	    } /* fi */
	} /* re-fi */
      mixer_elt = mixer_elt->next_mixer_elt;
    } /* while */
  return (0);
} /* fill_dsp_buffer */



/*
** ---------- writing the buffers to the dsps.
*/

int write_to_dsps(main_mixer, write_bytes)
     t_main_mixer* main_mixer;
     int           write_bytes;
{
  int result;
  t_mixer_elt* mixer_elt;

  mixer_elt = main_mixer->first_mixer_elt;
  while (mixer_elt != NULL)
    {
      if ((mixer_elt->rec_or_play == PLAY) && (mixer_elt->finished == FALSE_)&& 
	  (mixer_elt->mute == FALSE_))
	{
	  if (mixer_elt->dsp->processed == FALSE_)
	    {
	      result = write(mixer_elt->dsp->file, mixer_elt->dsp->buffer, write_bytes);
	      if (result <= 0)
		warning("PlayBuffers.c: write_to_dsps: Error writing to one of the dsps. This can be due"
			"to the fact that your sound card is not full-duplex."); /* mark */
	      mixer_elt->dsp->processed = TRUE_;
	    } /* fi */
	} /* re-fi */
      mixer_elt = mixer_elt->next_mixer_elt;
    } /* while */

  return (result);
} /* write_to_dsps */


// ----------- PUBLIC -----------

/*
** ---------- Global update of mixer 
*/

int play_buffers(main_mixer)
     t_main_mixer* main_mixer;
{

  int          result;
  t_mixer_elt* mixer_elt;

  result = 0;

  // Reading wave files buffers.
  mixer_read_files_buffers(main_mixer, &result);

  // Filling big_buf.
  fill_big_buffers(main_mixer);

  // Reinitializing 'processed' flags. 
  init_processed_flags(main_mixer);

  // Adjusting volume and filling dsp buffers.
  fill_dsp_buffer(main_mixer);

  // Reinitializing 'processed' flags. 
  init_processed_flags(main_mixer);
 
  // writing the buffers to the dsps.
  write_to_dsps(main_mixer, result);

  main_mixer->played_samples += (result / 4);
  
  // verifying that the starting date is not after the read words
  mixer_elt = main_mixer->first_mixer_elt;

  //  printf("Result before: %d\n",result);
  while (mixer_elt != NULL)
    {
      //printf("date = %d ; played = %d\n",mixer_elt->mixer_info->begin_date,main_mixer->played_samples);
      if ((mixer_elt->mixer_info->begin_date >= main_mixer->played_samples) && (result == 0))
	{
	  result = 1;
	  //printf("begin_date %d >= played_samples %d\n",mixer_elt->mixer_info->begin_date,main_mixer->played_samples);
	}
      mixer_elt = mixer_elt->next_mixer_elt;
      //printf("mixer_elt = %d\n",(int) mixer_elt); 
    }

  return (result);

} /* play_buffers */
